package com.example;

import akka.actor.typed.ActorRef;
import akka.actor.typed.Behavior;
import akka.actor.typed.javadsl.AbstractBehavior;
import akka.actor.typed.javadsl.ActorContext;
import akka.actor.typed.javadsl.Behaviors;
import akka.actor.typed.javadsl.Receive;

import java.util.ArrayList;
import java.util.Collections;


public class AddressBook extends AbstractBehavior<AddressBook.Message> {
    ArrayList<ActorRef<Customer.Message>> customers;
    public interface Message {}
    public record CustomerMessage(ActorRef<Customer.Message> fragender, String nameFragender) implements Message{}
    public record Response(ActorRef<Customer.Message> addresse) implements Message{}

    @Override
    public Receive<AddressBook.Message> createReceive() {
        return newReceiveBuilder()
                .onMessage(CustomerMessage.class, this::onCustomerMessage)
                .build();
    }

    public static Behavior<AddressBook.Message> create(ArrayList<ActorRef<Customer.Message>> custo){
        return Behaviors.setup(context -> new AddressBook(context, custo));
    }

    private AddressBook(ActorContext<AddressBook.Message> context, ArrayList<ActorRef<Customer.Message>> actors){
        super(context);
        customers = actors;
    }

    //Methode, um einen zufälligen Empfänger auszugeben (wahrscheinlich das Senden am Ende noch nicht ganz richtig)
    public Behavior<Message> onCustomerMessage(CustomerMessage msg){
        Collections.shuffle(customers);
        var adressOf = customers.get(0);
        getContext().getLog().info("{} asked for an adress",msg.nameFragender);
        msg.fragender().tell((Customer.Message) new Response(adressOf).addresse);
        return this;
    }
}
